package core.engine.terrain;

import core.engine.Loader;
import core.engine.model.RawModel;
import core.engine.textures.ModelTexture;

import java.util.ArrayList;
import java.util.List;

public class Terrain {

    private static final float SIZE = 100;

    private static final int VERTEX_COUNT = 128;

    private float x;
    private float z;

    private List<TerrainTile> terrainTiles = new ArrayList<>();

    public Terrain(int gridX, int gridZ, Loader loader, ModelTexture modelTexture) {
        this.x = gridX * SIZE;
        this.z = gridZ * SIZE;

        for (int row = 0; row < VERTEX_COUNT - 1; row++) {
            for (int column = 0; column < VERTEX_COUNT - 1; column++) {
                TerrainTile terrainTile = new TerrainTile(loader, modelTexture, row, column, VERTEX_COUNT, SIZE);
                terrainTiles.add(terrainTile);
            }
        }
    }

    public float getX() {
        return x;
    }

    public float getZ() {
        return z;
    }

    public List<TerrainTile> getTerrainTiles() {
        return terrainTiles;
    }

    public void setTerrainTiles(List<TerrainTile> terrainTiles) {
        this.terrainTiles = terrainTiles;
    }
}
